VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl icTreeview1 
   ClientHeight    =   1905
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2685
   LockControls    =   -1  'True
   ScaleHeight     =   1905
   ScaleWidth      =   2685
   ToolboxBitmap   =   "TreeView.ctx":0000
   Begin MSComctlLib.TreeView TV 
      Height          =   1860
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2640
      _ExtentX        =   4657
      _ExtentY        =   3281
      _Version        =   393217
      HideSelection   =   0   'False
      Indentation     =   529
      LabelEdit       =   1
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   161
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "icTreeview1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'#########################################################

' Treeview.ocx
' A UserControl made with a VB6 Treeview control (MSCOMCTL.OCX - 6.00.8862)
' with customized Background (Color, GradientRectHor, GradientRectHor
' GradientTri, tiled Picture), Backcolor, Forecolor, Buttons, Tooltips etc.

' Copyright  2001 Panos Koutsoukeras
' Company:  Inspired Creations
' Web:      http://globalinspired.com
' Mail:     software@globalinspired.com
' Date:     16 July 2001

' Credits:
' Ben Baird, http://www.vbthunder.com
' Brad Martinez, http://www.mvps.org
' http://vbaccelerator.com/

' Limitations:
' The UserControl does not repaint correctly if the
' ClipControls property of the Form1 has been set to False
'
' Some of the Background options behave strangely, because
' of the Treeview control, but this is only a demo, showing
' some ways to draw on a VB6 Treeview background.
'
' If Background = fvGrdntRectVer or fvGrdntTri
' or fvPicturedTiled (m_BackScroll = True) then the control
' does not show Tooltips and Scrolls one at a time

'#########################################################

' In all other cases we have tooltips and Scrolls Ok
Option Explicit

Implements cSubclass

Private TTStd As cToolTip    ' Tooltip standard

'Property Variables:
Private m_Background As efvBackground
Private m_BackScroll As Boolean
Private m_BackColor As OLE_COLOR
Private m_ForeColor As OLE_COLOR
Private m_BorderStyle As efvBordersStyle

Private m_HasLinesAtRoot As Boolean
Private m_HasLines As Boolean
Private m_HasButtons As Boolean
Private m_ButtonSet As efvButtonSet

Private m_Indent As Single
Private m_ToolTips As efvTooltips
Private m_Picture As Picture

' Paint variables
Private memDC(1 To 3) As MemoryDC
Private RC As RECT
Private TVWidth As Long         ' Treeview width
Private TVHeight As Long        ' Treeview height
Private m_lHdc As Long          ' Stores a copy of the Picture in the memory
Private lBitmapW As Long        ' Picture's Width
Private lBitmapH As Long        ' Picture's Height
Private XOriginOffset As Long   ' The x coord of the first Item's(Root) Rect
Private YOriginOffset As Long   ' The y coord of the first Item's(Root) Rect
Private m_lXOffset As Long
Private bStopPaint As Boolean   ' Flag to prevent painting
Private prevItem As Node        ' Stores the previous node (MouseOver)

Private gRect As GRADIENT_RECT
Private gTri(1) As GRADIENT_TRIANGLE
Private vert(3) As TRIVERTEX

Private bCustButtons As Boolean ' Custom buttons
Private UChwnd As Long          ' User Control's hwnd

'Default Property Values:
Private Const m_def_Background = 0
Private Const m_def_BackScroll = False
Private Const m_def_BackColor = &H80000005  ' Window background
Private Const m_def_ForeColor = &H80000008  ' Window Text
Private Const m_def_BorderStyle = 1

Private Const m_def_HasLines = True
Private Const m_def_HasButtons = True
Private Const m_def_HasLinesAtRoot = True

Private Const m_def_Indent = 19 ' Pixels
Private Const m_def_Tooltips = False
Private Const m_def_ButtonSet = 0

' User Control's Background
Public Enum efvBackground
    fvgNone
    fvColor
    fvGrdntRectHor
    fvGrdntRectVer
    fvGrdntTri
    fvPicturedTiled
End Enum

' User Control's Borders
Public Enum efvBordersStyle
    fvbNone
    fvSingle
End Enum

' User Control's ButtonSet (These are the checkboxes)
Public Enum efvButtonSet
    fvNormal
    fvCustom
End Enum

' User Control's Tooltips
Public Enum efvTooltips
    fvtNone
    fvName  ' Works OK only if BackScroll = True or if bStopPaint = True, if we have a background
    fvTag   ' Works OK only if BackScroll = True or if bStopPaint = True, if we have a background
End Enum

'Event Declarations:
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=TV,TV,-1,MouseDown
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=TV,TV,-1,MouseMove
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=TV,TV,-1,MouseUp
Public Event Click() 'MappingInfo=TV,TV,-1,Click
Public Event DblClick() 'MappingInfo=TV,TV,-1,DblClick

Public Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=TV,TV,-1,KeyDown
Public Event KeyPress(KeyAscii As Integer) 'MappingInfo=TV,TV,-1,KeyPress
Public Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=TV,TV,-1,KeyUp

Public Event Expand(ByVal Node As Node) 'MappingInfo=TV,TV,-1,Expand
Public Event Collapse(ByVal Node As Node) 'MappingInfo=TV,TV,-1,Collapse
Public Event NodeCheck(ByVal Node As Node) 'MappingInfo=TV,TV,-1,NodeCheck
Public Event NodeClick(ByVal Node As Node) 'MappingInfo=TV,TV,-1,NodeClick

Private Sub UserControl_InitProperties()

    m_BackColor = m_def_BackColor
    m_Background = m_def_Background
    m_BackScroll = m_def_BackScroll
    m_ForeColor = m_def_ForeColor
    m_BorderStyle = m_def_BorderStyle
    
    m_HasLinesAtRoot = m_def_HasLinesAtRoot
    m_HasLines = m_def_HasLines
    m_HasButtons = m_def_HasButtons
    m_ButtonSet = m_def_ButtonSet

    m_Indent = m_def_Indent
    m_ToolTips = m_def_Tooltips
    
    Set m_Picture = LoadPicture("")

End Sub

Private Sub UserControl_Initialize()
  
  Dim i As Integer
  Dim Node1 As Node
  Dim Node2 As Node
    
    ' Fill up the treeview with Sample Nodes ala original
    Set Node1 = TV.Nodes.Add(, , , "Sample Node")
    For i = 1 To 2
        Set Node2 = TV.Nodes.Add(Node1.Index, tvwChild, , "Sample Node")
    Next
    Node1.Expanded = True
    Set Node1 = TV.Nodes.Add(, , , "Sample Node")
    
    ' We need to subclass the TreeView to catch notification messages
    Subclass

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  
  Dim i As Integer
  Dim lColor As Long
  Dim Style As Long
    
    ' Clear the Samples
    If Ambient.UserMode Then
        EmptyTreeView TV
    End If

    m_Background = PropBag.ReadProperty("Background", m_def_Background)
    m_BackScroll = PropBag.ReadProperty("BackScroll", m_def_BackScroll)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)

    m_HasLinesAtRoot = PropBag.ReadProperty("HasLinesAtRoot", m_def_HasLinesAtRoot)
    m_HasLines = PropBag.ReadProperty("HasLines", m_def_HasLines)
    m_HasButtons = PropBag.ReadProperty("HasButtons", m_def_HasButtons)
    m_ButtonSet = PropBag.ReadProperty("ButtonSet", m_def_ButtonSet)

    m_Indent = PropBag.ReadProperty("Indent", m_def_Indent)
    m_ToolTips = PropBag.ReadProperty("Tooltips", m_def_Tooltips)
    
    Appearance = PropBag.ReadProperty("Appearance", 1)
    CheckBoxes = PropBag.ReadProperty("Checkboxes", False)
    Enabled = PropBag.ReadProperty("Enabled", True)
    HideSelection = PropBag.ReadProperty("HideSelection", False)
    HotTracking = PropBag.ReadProperty("HotTracking", False)
    FullRowSelect = PropBag.ReadProperty("FullRowSelect", False)
    LabelEdit = PropBag.ReadProperty("LabelEdit", 1)
    OLEDragMode = PropBag.ReadProperty("OLEDragMode", 0)
    OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    Scroll = PropBag.ReadProperty("Scroll", True)
    
    Set m_Picture = PropBag.ReadProperty("Picture", Nothing)
    Set ImageList = PropBag.ReadProperty("ImageList", Nothing)
    
    ' If Background = fvGrdntRectVer or fvGrdntTri
    ' or fvPicturedTiled (BackScroll = True) then the
    ' control does not show Tooltips
    Select Case m_Background
        Case fvgNone, fvGrdntRectVer, fvGrdntTri
            bStopPaint = False
        Case fvColor, fvGrdntRectHor
            bStopPaint = True
        Case fvPicturedTiled
            If m_BackScroll Then
                bStopPaint = True
                Else
                bStopPaint = False
            End If
    End Select
    
    If Not m_Picture Is Nothing Then
        GetBitmapIntoDC
    End If

    If m_HasLinesAtRoot Then
        TV.LineStyle = tvwRootLines
        Else
        TV.LineStyle = tvwTreeLines
    End If
    
    If m_ButtonSet = fvCustom Then
        ' Turn off the NORMAL buttons
        bCustButtons = True
        Else
        bCustButtons = False
    End If

    ' HasLines = True
    If m_HasLines Then
        ' HasButtons = True
        If m_HasButtons Then
            ' ButtonSet = fvCustom
            If bCustButtons Then
                TV.Style = tvwTreelinesPictureText
                ' ButtonSet = fvNormal
                Else
                TV.Style = tvwTreelinesPlusMinusPictureText
            End If
            ' HasButtons = False
            Else
            TV.Style = tvwTreelinesPictureText
        End If
        ' HasLines = False
        Else
        ' HasButtons = True
        If m_HasButtons Then
            ' ButtonSet = fvCustom
            If bCustButtons Then
                TV.Style = tvwPictureText
                ' ButtonSet = fvNormal
                Else
                TV.Style = tvwPlusPictureText
            End If
            ' HasButtons = False
            Else
            TV.Style = tvwPictureText
        End If
    End If

    ' Get the TV style (For Tooltips)
    Style = GetWindowLong(TVhwnd, GWL_STYLE)
  
    ' Remove the Tooltips from the treeview because they are bugy
    Call SetWindowLong(TVhwnd, GWL_STYLE, Style Or TVS_NOTOOLTIPS)

    ' If we want tooltips we will set our own
    If m_ToolTips > fvtNone Then
        If TTStd Is Nothing Then
            Set TTStd = New cToolTip
            ' Initialize TTstd tooltip object
            With TTStd
                '.BkColor = &H0&
                '.TxtColor = &HFFFF&
                .DelayTime = 500
                .VisibleTime = 3000
                .TipWidth = 300
                .Style = ttStyleStandard
            End With
        End If
    End If
    
    ' If in Design mode then Unsubclass
    If Ambient.UserMode = False Then Unsubclass

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Appearance", TV.Appearance, 1)
    Call PropBag.WriteProperty("Background", m_Background, m_def_Background)
    Call PropBag.WriteProperty("BackScroll", m_BackScroll, m_def_BackScroll)
    Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    
    Call PropBag.WriteProperty("HasLinesAtRoot", m_HasLinesAtRoot, m_def_HasLinesAtRoot)
    Call PropBag.WriteProperty("HasLines", m_HasLines, m_def_HasLines)
    Call PropBag.WriteProperty("HasButtons", m_HasButtons, m_def_HasButtons)
    Call PropBag.WriteProperty("ButtonSet", m_ButtonSet, m_def_ButtonSet)
    
    Call PropBag.WriteProperty("Checkboxes", TV.CheckBoxes, False)
    Call PropBag.WriteProperty("Indent", m_Indent, m_def_Indent)
    Call PropBag.WriteProperty("Tooltips", m_ToolTips, m_def_Tooltips)
    
    Call PropBag.WriteProperty("HideSelection", TV.HideSelection, False)
    Call PropBag.WriteProperty("HotTracking", TV.HotTracking, False)
    Call PropBag.WriteProperty("FullRowSelect", TV.FullRowSelect, False)
    Call PropBag.WriteProperty("LabelEdit", TV.LabelEdit, 1)
    Call PropBag.WriteProperty("OLEDragMode", TV.OLEDragMode, 0)
    Call PropBag.WriteProperty("OLEDropMode", TV.OLEDropMode, 0)
    Call PropBag.WriteProperty("Scroll", TV.Scroll, True)
    
    Call PropBag.WriteProperty("Picture", m_Picture, Nothing)
    Call PropBag.WriteProperty("ImageList", ImageList, Nothing)

End Sub

Private Sub UserControl_Terminate()

  Dim i As Long

    ' Unsubclass the TreeView
    Call Unsubclass
 
    ' Clear up the objects
    Set m_Picture = Nothing
    Set TTStd = Nothing
    
    For i = 1 To 3
        ClearMemDC i
    Next i

End Sub

Private Sub UserControl_Resize()

  On Error Resume Next
    
    TV.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    InvalidateRect TVhwnd, 0, 0

End Sub




























'########################## EVENTS ##########################

Private Sub TV_Click()
    
    RaiseEvent Click

End Sub

Private Sub TV_DblClick()
    
    RaiseEvent DblClick

End Sub

Private Sub TV_KeyDown(KeyCode As Integer, Shift As Integer)
    
    RaiseEvent KeyDown(KeyCode, Shift)

End Sub

Private Sub TV_KeyPress(KeyAscii As Integer)
    
    RaiseEvent KeyPress(KeyAscii)

End Sub

Private Sub TV_KeyUp(KeyCode As Integer, Shift As Integer)
    
    RaiseEvent KeyUp(KeyCode, Shift)

End Sub

' If the selected Node has no child Nodes, and the Node's button is clicked,
' remove the Button

' Invoked after the TreeView sends any TVN_GETDISPINFOs, but before
' it sends any NM_CLICK, NM_DBLCLK, TVN_SELCHANGING or
' TVN_ITEMEXPANDING.
Private Sub TV_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    RaiseEvent MouseDown(Button, Shift, x, y)
    
    ' Exit if the control uses Checkboxes
    If TV.CheckBoxes Then Exit Sub
  
  Dim TVHTI As TVHITTESTINFO
  Dim Nod As Node
  
    If (Button = vbLeftButton) Then
        ' Get the item under the cursor (if any).
        TVHTI.pt.x = x / Screen.TwipsPerPixelX
        TVHTI.pt.y = y / Screen.TwipsPerPixelY
        ' If there is an Item
        If TreeView_HitTest(TVhwnd, TVHTI) Then
            ' If the item's state icon was left-clicked...
            If (TVHTI.flags = TVHT_ONITEMSTATEICON) Then
                ' Get the Node under the cursor, and toggle its expanded state.
                Set Nod = TV.HitTest(x, y)
                If (Nod Is Nothing) = False Then
                    Nod.Expanded = Not Nod.Expanded
                End If
            End If
        End If
    End If

End Sub

Private Sub TV_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  
  Dim TVHTI As TVHITTESTINFO
  Dim Nod As Node
  Dim RCItem As RECT
    
    RaiseEvent MouseMove(Button, Shift, x, y)
    
'------------------- Tooltips -------------------------
    ' If we want Tooltips we already have set one
    If Not TTStd Is Nothing Then
        ' Get the item under the cursor (if any).
        TVHTI.pt.x = x / Screen.TwipsPerPixelX
        TVHTI.pt.y = y / Screen.TwipsPerPixelY

        ' If the mouse is over an Item
        If TreeView_HitTest(TVhwnd, TVHTI) Then
            ' Get the Node under the cursor
            Set Nod = TV.HitTest(x, y)
            ' If we got the Node
            If (Nod Is Nothing) = False Then
                ' If this is not the first time we set a tooltip
                If (prevItem Is Nothing) = False Then
                    ' If it is different than prevItem
                    If Not prevItem = Nod Then
                        ' Set the Tooltip
                        TTStd.DelToolTip TVhwnd
                        ' If we want the Name
                        If m_ToolTips = fvName Then
                            TTStd.SetToolTip Nod.Text, False
                            ' If we want the Tag
                            Else
                            TTStd.SetToolTip Nod.Tag, False
                        End If
                        Set prevItem = Nod
                    End If
                    ' If this is the first time we set a tooltip
                    Else
                    ' Set the Tooltip
                    TTStd.DelToolTip TVhwnd
                    ' If we want the Name
                    If m_ToolTips = fvName Then
                        TTStd.SetToolTip Nod.Text, False
                        ' If we want the Tag
                        Else
                        TTStd.SetToolTip Nod.Tag, False
                    End If
                    Set prevItem = Nod
                End If
                ' Mouse is moving over the rest area
                Else
                Set prevItem = Nothing
                TTStd.DelToolTip TVhwnd
            End If
            ' Mouse is moving over the rest area
            Else
            Set prevItem = Nothing
            TTStd.DelToolTip TVhwnd
        End If
    End If
'--------------------------------------------------------

End Sub

Private Sub TV_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    RaiseEvent MouseUp(Button, Shift, x, y)

End Sub

Private Sub TV_NodeClick(ByVal Node As Node)

    RaiseEvent NodeClick(Node)
    
End Sub

Private Sub TV_Collapse(ByVal Node As Node)
    
    RaiseEvent Collapse(Node)

    ' If we want Custom buttons
    If m_HasButtons And bCustButtons Then
        Call SetTVItemStateImage(TVhwnd, Node, tvisCollapsed)
    End If

End Sub

Private Sub TV_Expand(ByVal Node As Node)
    
    RaiseEvent Expand(Node)
    
    ' If we want Custom buttons
    If m_HasButtons And bCustButtons Then
        Call SetTVItemStateImage(TVhwnd, Node, tvisExpanded)
    End If

End Sub

Private Sub TV_NodeCheck(ByVal Node As Node)
    
    RaiseEvent NodeCheck(Node)

End Sub




























'######################### PROPERTIES #######################

Public Property Get hWnd() As Long

    hWnd = TVhwnd

End Property

Public Property Get Nodes() As Nodes
   
   Set Nodes = TV.Nodes

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,Appearance
Public Property Get Appearance() As AppearanceConstants
    
    Appearance = TV.Appearance

End Property

Public Property Let Appearance(ByVal New_Appearance As AppearanceConstants)
    
    TV.Appearance() = New_Appearance
    PropertyChanged "Appearance"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=31,0,0,0
Public Property Get Background() As efvBackground
    
    Background = m_Background

End Property

Public Property Let Background(ByVal New_Background As efvBackground)
    
    ' If m_Background = fvGrdntRectVer or fvGrdntTri
    ' or fvPicturedTiled (m_BackScroll = True) then
    ' does not show Tooltips
    
    ' Set the bStopPaint Flag
    Select Case New_Background
        ' Scroll OK, Tooltips OK
        Case fvgNone, fvColor, fvGrdntRectHor
            m_Background = New_Background
            m_BackScroll = False
            bStopPaint = False
        ' Scroll ONE, Tooltips NO
        Case fvGrdntRectVer, fvGrdntTri
            m_Background = New_Background
            m_BackScroll = False
            m_ToolTips = fvtNone
            bStopPaint = False
            MsgBox "Tooltips = ftvNone and BackScroll = False.", vbCritical, "Properties changed"
        Case fvPicturedTiled
            If m_Picture Is Nothing Then
                Beep
                MsgBox "Please select a Picture first!", vbCritical, "Invalid Picture"
                Else
                m_Background = New_Background
                ' Scroll ONE, Tooltips NO
                If m_BackScroll = False Then
                    m_ToolTips = fvtNone
                    bStopPaint = False
                    MsgBox "Tooltips = ftvNone. Set BackScroll= True for Tooltips.", vbCritical, "Properties changed"
                    ' Scroll OK, Tooltips OK
                    Else
                    bStopPaint = True
                End If
            End If
    End Select
                
    PropertyChanged "Background"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get BackScroll() As Boolean
    
    BackScroll = m_BackScroll

End Property

Public Property Let BackScroll(ByVal New_BackScroll As Boolean)
    
    m_BackScroll = New_BackScroll
    ' Allow Scroll only if Background = fvPicturedTiled
    If Background <> fvPicturedTiled Then
        m_BackScroll = False
        ' Scroll OK, Tooltips OK
        If m_BackScroll Then
            bStopPaint = True
            ' Scroll ONE, Tooltips NO
            Else
            bStopPaint = False
        End If
    End If
    PropertyChanged "BackScroll"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColor() As OLE_COLOR

    BackColor = m_BackColor

End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)

    m_BackColor = New_BackColor
    If m_Background = fvColor Then
        PrepareRect TV
        SetBackColor memDC(2).MemHDC, m_BackColor
    End If
    PropertyChanged "BackColor"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get ForeColor() As OLE_COLOR
    
    ForeColor = m_ForeColor

End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)

  Dim lColor As Long

    m_ForeColor = New_ForeColor

    ' Set the colour in the TreeView:
    lColor = TranslateColor(m_ForeColor)
    SendMessageLong TV.hWnd, TVM_SETTEXTCOLOR, 0, lColor
    ' Request a redraw:
    InvalidateRectAsNull TV.hWnd, 0, 1
    UpdateWindow TV.hWnd

    PropertyChanged "ForeColor"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=29,0,0,0
Public Property Get BorderStyle() As efvBordersStyle
    
    BorderStyle = m_BorderStyle

End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As efvBordersStyle)
    
    m_BorderStyle = New_BorderStyle
    TV.BorderStyle = m_BorderStyle
    PropertyChanged "BorderStyle"

End Property

Public Property Get Enabled() As Boolean
    
    Enabled = UserControl.Enabled

End Property

Public Property Let Enabled(ByVal bState As Boolean)

  Dim TVI As TVITEM
  Dim hItem As Long
  Dim lR As Long
  Dim lColor As Long
    
    TVI.mask = TVIF_STATE
    hItem = SendMessageLong(TV.hWnd, TVM_GETNEXTITEM, TVGN_ROOT, 0&)
    Do While hItem <> 0
        With TVI
            .hItem = hItem
            .mask = TVIF_STATE
            .stateMask = TVIS_CUT
            If (bState) Then
                .state = .stateMask And Not TVIS_CUT
                Else
                .state = .stateMask Or TVIS_CUT
            End If
            lR = SendMessage(TV.hWnd, TVM_SETITEM, 0&, TVI)
        End With
        hItem = SendMessageLong(TV.hWnd, TVM_GETNEXTITEM, TVGN_NEXTVISIBLE, hItem)
    Loop
    
    ' Set the Forecolor with Send Message because we do not
    ' want to change the ForeColor property
    If (bState) Then
        ' Set the colour in the TreeView:
        lColor = TranslateColor(m_ForeColor)
        SendMessageLong TV.hWnd, TVM_SETTEXTCOLOR, 0, lColor
        ' Request a redraw:
        InvalidateRectAsNull TV.hWnd, 0, 1
        UpdateWindow TV.hWnd
        Else
        ' Set the colour in the TreeView:
        lColor = TranslateColor(vbGrayText)
        SendMessageLong TV.hWnd, TVM_SETTEXTCOLOR, 0, lColor
        ' Request a redraw:
        InvalidateRectAsNull TV.hWnd, 0, 1
        UpdateWindow TV.hWnd
    End If
    
    UserControl.Enabled = bState
    PropertyChanged "Enabled"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get HasLinesAtRoot() As Boolean
    
    HasLinesAtRoot = m_HasLinesAtRoot

End Property

Public Property Let HasLinesAtRoot(ByVal New_HasLinesAtRoot As Boolean)
    
    m_HasLinesAtRoot = New_HasLinesAtRoot
    If m_HasLinesAtRoot Then
        TV.LineStyle = tvwRootLines
        Else
        TV.LineStyle = tvwTreeLines
    End If
    PropertyChanged "HasLinesAtRoot"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get HasLines() As Boolean
    
    HasLines = m_HasLines

End Property

Public Property Let HasLines(ByVal New_HasLines As Boolean)
    
    m_HasLines = New_HasLines
    If m_HasLines Then
        If m_HasButtons Then
            TV.Style = tvwTreelinesPlusMinusPictureText
            Else
            TV.Style = tvwTreelinesPictureText
        End If
        Else
        If m_HasButtons Then
            TV.Style = tvwPlusPictureText
            Else
            TV.Style = tvwPictureText
        End If
    End If
    PropertyChanged "HasLines"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get HasButtons() As Boolean
    
    HasButtons = m_HasButtons

End Property

Public Property Let HasButtons(ByVal New_HasButtons As Boolean)
    
    m_HasButtons = New_HasButtons
    If m_HasLines Then
        If m_HasButtons Then
            TV.Style = tvwTreelinesPlusMinusPictureText
            Else
            TV.Style = tvwTreelinesPictureText
        End If
        Else
        If m_HasButtons Then
            TV.Style = tvwPlusPictureText
            Else
            TV.Style = tvwPictureText
        End If
    End If
    PropertyChanged "HasButtons"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=32,0,0,fvNormal
Public Property Get ButtonSet() As efvButtonSet
    
    ButtonSet = m_ButtonSet

End Property

Public Property Let ButtonSet(ByVal New_ButtonSet As efvButtonSet)
    
    m_ButtonSet = New_ButtonSet
    ' Change the property only if the Treeview Has buttons
    If m_HasButtons = True Then
        ' Normal buttons
        If m_ButtonSet = fvNormal Then
            If m_HasLines Then
                TV.Style = tvwTreelinesPlusMinusPictureText
                Else
                TV.Style = tvwPlusPictureText
            End If
            ' Custom buttons
            Else
            If m_HasLines Then
                TV.Style = tvwTreelinesPictureText
                Else
                TV.Style = tvwPictureText
            End If
        End If
    End If
    
    If m_ButtonSet = fvCustom And CheckBoxes = True Then
        CheckBoxes = False
        MsgBox "Checkboxes = False.", vbCritical, "Property changed"
    End If
    
    ' Set the bCustButtons flag
    If m_ButtonSet = fvNormal Then
        bCustButtons = False
        Else
        bCustButtons = True
    End If
    
    PropertyChanged "ButtonSet"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,CheckBoxes
Public Property Get CheckBoxes() As Boolean
    
    CheckBoxes = TV.CheckBoxes

End Property

Public Property Let CheckBoxes(ByVal New_CheckBoxes As Boolean)

    TV.CheckBoxes() = New_CheckBoxes
    If New_CheckBoxes = True And m_ButtonSet = fvCustom Then
        m_ButtonSet = fvNormal
        MsgBox "ButtonSet = fvNormal.", vbCritical, "Property changed"
    End If
    PropertyChanged "Checkboxes"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,Indentation
Public Property Get Indent() As Single ' In Pixels

    Indent = Int(TV.Indentation / Screen.TwipsPerPixelX)

End Property

Public Property Let Indent(ByVal New_Indent As Single) ' In Pixels

  On Error GoTo errIndent

    m_Indent = New_Indent
    TV.Indentation() = m_Indent * Screen.TwipsPerPixelX
    PropertyChanged "Indent"

  Exit Property

errIndent:
    Indent = 19
    TV.Indentation() = Indent * Screen.TwipsPerPixelX
    PropertyChanged "Indent"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=32,0,0
Public Property Get ToolTips() As efvTooltips
    
    ToolTips = m_ToolTips

End Property

Public Property Let ToolTips(ByVal New_ToolTips As efvTooltips)
    
    m_ToolTips = New_ToolTips
    
    ' Check if tooltips are allowed
    Select Case m_Background
        Case fvGrdntRectVer, fvGrdntTri
            m_ToolTips = fvtNone
        Case fvPicturedTiled
            If m_BackScroll = False Then m_ToolTips = fvtNone
    End Select
    
    PropertyChanged "Tooltips"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,HideSelection
Public Property Get HideSelection() As Boolean
    
    HideSelection = TV.HideSelection

End Property

Public Property Let HideSelection(ByVal New_HideSelection As Boolean)
    
    TV.HideSelection() = New_HideSelection
    PropertyChanged "HideSelection"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,HotTracking
Public Property Get HotTracking() As Boolean
    
    HotTracking = TV.HotTracking

End Property

Public Property Let HotTracking(ByVal New_HotTracking As Boolean)
    
    TV.HotTracking() = New_HotTracking
    PropertyChanged "HotTracking"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,FullRowSelect
Public Property Get FullRowSelect() As Boolean
    
    FullRowSelect = TV.FullRowSelect

End Property

Public Property Let FullRowSelect(ByVal New_FullRowSelect As Boolean)
    
    TV.FullRowSelect() = New_FullRowSelect
    PropertyChanged "FullRowSelect"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,LabelEdit
Public Property Get LabelEdit() As LabelEditConstants
    
    LabelEdit = TV.LabelEdit

End Property

Public Property Let LabelEdit(ByVal New_LabelEdit As LabelEditConstants)
    
    TV.LabelEdit() = New_LabelEdit
    PropertyChanged "LabelEdit"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,OLEDragMode
Public Property Get OLEDragMode() As OLEDragConstants
    
    OLEDragMode = TV.OLEDragMode

End Property

Public Property Let OLEDragMode(ByVal New_OLEDragMode As OLEDragConstants)
    
    TV.OLEDragMode() = New_OLEDragMode
    PropertyChanged "OLEDragMode"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,OLEDropMode
Public Property Get OLEDropMode() As OLEDropConstants
    
    OLEDropMode = TV.OLEDropMode

End Property

' There is a problem if OleDropMode = 2 ???
Public Property Let OLEDropMode(ByVal New_OLEDropMode As OLEDropConstants)
    
  On Error GoTo OLer
    
    TV.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"

  Exit Property

OLer:

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,Scroll
Public Property Get Scroll() As Boolean
    
    Scroll = TV.Scroll

End Property

Public Property Let Scroll(ByVal New_Scroll As Boolean)
    
    TV.Scroll() = New_Scroll
    PropertyChanged "Scroll"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=11,0,0,0
Public Property Get Picture() As Picture

    Set Picture = m_Picture

End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    
    Set m_Picture = New_Picture
    
    ' Load the Picture into a memory DC
    ' and get its dimensions
    If Not New_Picture Is Nothing Then
        GetBitmapIntoDC
        ' Picture is cleared
        Else
        m_Background = fvgNone
        m_BackScroll = False
        MsgBox "Background = fbgNone", vbCritical, "Property changed"
    End If
    
    TV.Refresh
    PropertyChanged "Picture"

End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=TV,TV,-1,ImageList
Public Property Get ImageList() As Object

    Set ImageList = TV.ImageList

End Property

Public Property Set ImageList(ByVal New_ImageList As Object)

    Set TV.ImageList = New_ImageList
    PropertyChanged "ImageList"

End Property






























'###################### SUBCLASSING #####################

Private Sub Subclass()
    
    Unsubclass

    TVhwnd = TV.hWnd
    UChwnd = UserControl.hWnd

    AttachMessage Me, TVhwnd, TVM_INSERTITEM
    AttachMessage Me, TVhwnd, WM_PAINT
    AttachMessage Me, TVhwnd, WM_ERASEBKGND
    AttachMessage Me, TVhwnd, WM_DESTROY
    AttachMessage Me, UChwnd, WM_NOTIFY

End Sub

Private Sub Unsubclass()

    If TVhwnd <> 0 Then
        DetachMessage Me, TVhwnd, TVM_INSERTITEM
        DetachMessage Me, TVhwnd, WM_PAINT
        DetachMessage Me, TVhwnd, WM_ERASEBKGND
        DetachMessage Me, TVhwnd, WM_DESTROY
        DetachMessage Me, UChwnd, WM_NOTIFY
    End If
    
    TVhwnd = 0
    UChwnd = 0

End Sub

Private Property Let cSubclass_MsgResponse(ByVal RHS As EMsgResponse)

   '

End Property

Private Property Get cSubclass_MsgResponse() As EMsgResponse

    If CurrentMessage = WM_PAINT Or CurrentMessage = WM_ERASEBKGND Or CurrentMessage = WM_DESTROY Or CurrentMessage = TVM_INSERTITEM Then
        cSubclass_MsgResponse = emrConsume
        Else
        cSubclass_MsgResponse = emrPreprocess
    End If

End Property

Private Function cSubclass_WindowProc(ByVal hWnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  Dim i As Long
  Dim lR As Long
  Dim bR As Boolean
    
    Select Case iMsg
    
        Case WM_PAINT, WM_ERASEBKGND
            ' Do this only if we have selected a background
            If m_Background = fvgNone Then
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
              Exit Function
            End If
            If m_Background = fvPicturedTiled And m_Picture Is Nothing Then
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
              Exit Function
            End If
            ' Custom process the WM_PAINT and WM_ERASEBKGND messages
            TvWMPaint hWnd, iMsg, lR, bR
            If bR Then
                cSubclass_WindowProc = lR
                Else
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
            End If
        
        ' Set the Custom buttons (If any)
        ' This is Not the right way but works.
        ' We should better get a TVINSERTSTRUCT structure,
        ' change the state and stateMask members of its
        ' TVITEMEX or TVITEM member, and then use the
        ' TreeView_InsertItem macro to insert the Item.
        Case TVM_INSERTITEM
          On Error Resume Next
            ' If the control has buttons AND CUSTOM buttons
            If m_HasButtons And m_ButtonSet = fvCustom Then
                ' Normal process
                ' We first insert the item to increase the TV.Nodes.Count
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
                ' Set the counter to the new(last) Item so
                ' i will be the index of the Node
                i = TV.Nodes.Count
                ' If it has Children
                If TV.Nodes(i).Children > 0 Then
                    Call SetTVItemStateImage(TVhwnd, TV.Nodes(i), tvisCollapsed)
                    ' If it has not Children
                    Else
                    Call SetTVItemStateImage(TVhwnd, TV.Nodes(i), tvisNoButton)
                End If
                ' Normal buttons
                Else
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
            End If
          
        ' Unsubclass the window.
        Case WM_DESTROY
            cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
            Call Unsubclass
          Exit Function
    End Select

End Function
































'####################### FUNCTIONS ########################

Private Sub MakeMemDC(ByVal SourceDC As Long, _
                            ByVal MemDCIndex As Long, _
                            ByVal MemDCWidth As Long, _
                            ByVal MemDCHeight As Long)
      
    With memDC(MemDCIndex)
        If MemDCWidth > .MemWidth Or MemDCHeight > .MemHeight Or .MemHDC = 0 Then
            ClearMemDC MemDCIndex
            ' Make a memory DC like the Treeview DC
            .MemHDC = CreateCompatibleDC(SourceDC)
            If .MemHDC <> 0 Then
                If SourceDC = 0 Then SourceDC = .MemHDC
                ' Specify the height, width, and color for the TempDC
                ' according to the Treeview DC
                .MemBmp = CreateCompatibleBitmap(SourceDC, MemDCWidth, MemDCHeight)
                ' If the Properties of the MemoryDC was set OK
                If .MemBmp <> 0 Then
                 Then
et OK
       e0arllusMillu of thelse
Width Or MemDCHeighMemBmp PT.f The End If
    End Not New_Picture Is NinesAtRoot(fgInfo=TedwImageList
Publ IEelse
WbTProperty Set Long, _
r Pict
PAi ClearMemDC t M     ClearMemD         EnWidt:IEelse
WbTProperty Set Long, _
r Pict
PAi Clea              If edTiled
H0H0H0H0H0H0HHHHWsemD  cde() As OLEDropConstants
  wImaotPa0"Yse)

   '
Pic1m_BConstants
  wImaoU:otPa0"Yse)VM_Ing
  Dim    U8 d matiHDC = 0 Theg
  Dim mso
          y Set Long, _
r Pict
PT_      Thent Theg
  Dim mso
          y R PT.f The End If
     The End Cr The Eb NeC
r The Eb NeC
r The Eb NI2Sl If TV.NrmestbTPropeTdUChwnd, NI2Sl If TV.NrmestbTPropeTdUChwtmory NI2Sl If rty Get Bac, TVhwnd, WM_ERA0TEAttachMessage Me, UChwno,Eb NI2Sl If TV.Nrmestbrst inseessage MeOb NI2SlLong, _
oEitl BackTdUChwtmory NI2OLong,wProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
   y NI2OLNIFY .ub
o                s  Dimg, _
              sert the ir The Eb NeC
r The Eb NI2Sl IiedTiled
H0H0H0H0H0HHu           ' Ifb          ' Ifb          ' Ifb          ' Ifb          ' Ifb      h SubNeC
r The Eb NI2Sl IiedTiled
H0H NI2Sl IiedTiled
a        Call Uct(ByVal h Su=lEtKrled
H0H0H NI2Sl (ByVal h Su=lEtKrled
H0H0H NI2Sl (ByVal h cslass_M  = 2 ??yVal h cslas_M  = 2 fo=TV,TV,-1,HotTracking
Public Pro theiUr iMsg, wParam, lParam)
        Ytter geis_M  = iMsg, wParam, lPara   B'
    the am, lPara   B'
    the am, lPara   B'
    the am, lPara   B'
    the am, lPara   B'
    the am, lPara   B'
    the am, lPara   B'
1MSTROYXNertyChanged )
        Ytter
    Set m_Picture = New_Picture
    
  cB'
1MSTROYXs_M_Picture
,_    o0Case fvGrdntRectVer, fvGrotTrackine Me, U8,cbut worP  
  _ged )
                        ., lParam)
        Ytter geis_M  = iMsg, wParam, lPara   B'
    the am, lPara   B  Custom buttons
            Else
ra   B'
1MSTSblearMemDC MYtter geis_M  = iMsg,.lse
      -Msg,.lse
Msg,.lse
      -Msg,.lse
Msg,.lse
      -Msg,.lse
Msg,.lse
      -Msg,.lse
Msg,.lse
     TV.Scrol,otTrac he 
Msg,.lse
     TV.Scrol,otTrac he 
Msg,.lse
     TV.Scrol,ois_M0  
  _ged  
  _ge for the TempDC
       as set OK
           Cleae TempDC
    N   ud )
empDeaesbIiedlty changed"
    End If
   EDC
    N   ud )
empDeaesbIiedlty changedMsg, wParam, l  ud )
empDeaesbIiedl   mTrac he 
Msg,.lse
 )
            eeeeeeeeeeeeeeeeeee2Ue
 )
   CHe,.lse
TV,TV,-1            Call SetTVItemStateImage(TVhwnd, TV.N    Call SetTVItemStateImage(TVhwnd, TV.N    Call SetTVItemStateImage(TVhwnd, TV.Nl SetTVsafra ,AVusafra ,AVusafra ,AVusafra ,.CWVusafrTVsafra ,AVusafra eImage(TVhwnd, TV.N    Call SetTVItemh, .N    Callcra   B  C N    Callcra   B  C N    Callcra nedwImageList
P'
1MSu=lEtKrra nedwIma TVhwnd, TV.N    Call SetTVItemh, .N    CatRectVeI "aram, lPara           bStopPis_M  RN_6TotTracking
Publi ' Unsubclass the wiFii   Set m_Pictf   n'








 o




 o




 aGiVItemh, .N    ure = a ,Ab  -Msg,.lse
Msg,.N End If
   EDC
    N   ud )
empDeXoTVItemh, .N  ku,emh, .N  ku,emh, .N  ku,emh,-Msg,.lse
Msg,.N End If
   EDC
    Nerivate Sub   N   ,emh, .N  be tN  koC
    ,emh, .N iM
    ,emh, .N TW   = a ,Ab vriMsg, wProperty
ib   N   ,emh, tN e,###### SUB,RC   = a"Cddddd, .N iM
    ,emh, .N TW   = a ,Ab vriMsg, wProperty  = aTcemh, .N8, .N   Ab vriMsg, wProrue)
    U AtOt,###,mh, .N   .N  retT  Item.
       lEdb                ., lPar.rPicthe ir 
etT4        ,ku,e           C
MsgG= 2 ?
    ForeColor = m_sg,.lse
Msg,.N End If
   EDC
    N   ud3I' Load theCHe,.lse
TV,TVb             ., lPa e As        TVpf
   EDC .N  ku,emh,-Msg,.lse
Msg,    C(S.oeMsg,    C(S.oeMsg,Lf
-wG! DO NOT REMOVE(xMsg,.lse
b New_Picture As P Tooltips from the treeview becOVE(xMsg,.lse
bO1Ab vriMsg, w   N   ,emh,e Me, TVhwnd1AIf
   EO NOT REMOVE(xMsg, D TW  N (, w   N   ,emh,=mDCIndex)
      
wam,., lPa e As  lse
bO1Ab vriMs  o0Case fvse
bperties ogMode() As OLEDragConstants
    
   oLO3I' Load thTna   y R PT.f (, w -w ,emh,=mDCIndex)
   emDCHeioTVI,emhUSEsNch YtehTW  N (   EDC
  ht)
                ' If tSNgeList"
t"
t"
t"
t"
t"
t"
t"
esbIiedl   m(  N   .N  retT  Item.
       lEdbge(TVhwn End If
   EDC
    N>ne(TVht"
t"
t"
esbIiedl   m(  N   .N  retT  Item.
       lEdbge(TVhwn End If
   EDC
    N>ne(TVht"
t"
      lEdbge(TVhwn E  Cl IEelsM     TV.   TV.   TV.   TV. V.   TV.   TV. e
  4lse
b New_PisTVhwn E  C1AIf
   EO NOT REMOVE(xMsg, D TW  N (, w  (TVhlse
bO1s   ' TreeView_I0N2F  TV.      CatRectVeIV1Bi   CatRectVehWnd, iMsg, wP!  ,oolTips
    
    ' r.olTips
    
    ' r.olTiclaiMsg, wP!  blO
  A
ra   B'
1MSTSblearMemDC,emhUSEsNch YtehTW  N (   EDC
'
1MSTSblearMemDC,em  N nd'
1MSTSblearMemDC,emhUSEsNch S,em  N nd'
1MSTSblearMslsg, wParmIf it w  (TVhlse
bO1s   w  (T'
1MSTSbl1MSm It EMsgR,_ButtonSet, m_dGu!  ,oolTips
    
    ' r.olTips
       NcGu!  ,ool,TW  N (, whe TempDC
 b vriMsg, 









, ByVoO)RColbeTSblearMslc = Ca cUvriMsg, 

Rges
riMsg, 

Rges
riMsg, 

Rges
riMsg, 

Rges
riMsg, 

Rges
riMsg, 

Rges
riMsg, 

Rgbk, 

Rgbk, 

RgbkolTicliMsedlMemHDC
     "iMsedlMemHDC
     "iMslh/

End Function


emHD
wam,.       cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
              Exit Function
    a(TVhwn E

 i  lEdbion
    ae Eb NeC
r Th
2F  TV.       ',   lEdbg,          ClearMemDC MemDc-Msg,.lse
MsE       Clea(dWindow2mmmm0 CleGu!  ,ool,TWs
          Exit ndowwwwwwwwwwtan(dWnd color for the T de Th
2F  TV.       ',Constants
uI,fo
 1oSbmmm0 CleGu!  ,ool,TWs
  it2la(dWi,TWs
  it2la(dWi,TDSeta(d  ,ool,TWs
Iew_InsertItuWs
  
"l,TWs
Iew_Inh      End         DIew'Clea(dWindow2mmmmi(dWi,TDSeta(d  ,ool,Tes
IelC(d  ,ool  c  lEdbionCew_Inserl,TeurooH'ehTW  N (ool  chE     End      se
Msg,.    cSubc     se
Msg,.   ,ool = a"Cddddd, .Mode", TV.OLEL  se
Msg,.    co
          ymiMsN TWdSs
uI,fo
 1oS     Yttehile hItem <> 0
mDC,emhUSEsNch YtehTW  N W  N (ool  chEbionriSEsNch    stTrackine M4BMsg,.   ,ooIass_WindowPro aGiVItemh,  ,emhcsSEsNch    stnd If
       () = m_Indent      (TVh"InsertItuWWindowPro aGC,emhUSEsNch onstants
uI,fo
 1yr=mhUSEsNch onstants
Wnd =a(d  ,oolllllllllllll
r The Eb NI2Sl  ThCThe Eb NI2Sl  ThCThe Eb NI2Sl  ThCThe Eb NI2Sl  p     >'The Eb NI2Sl  ThC:chE   The Eb 1yr=mhUSLNI2Sl  ThC:chtSEsNged"
    End If
  I2Sl  TR,iEb 
    End If
 vali   End If
I2Sluo
 1oSbmmm0 CleGu!  ,ool,TWs
  it2la(dWi,TWs
  it T REMOVE ORiIf
 vali   End Ifwwtan(dWnd cormaChanged "ImageList"

End he t

an(dWnd cormaEb 1 first insert thNOT REMOVE(xMsg,nsertItuWlPa e As           ' Ifb  N TW   EO NOT REMOR"R MODIFY THE a e As   B1sLinesAtR bng

    m_ForeColor = New_F0l1sLinesAtR bng
Nrmestbri 1yr=mhUSEsNchVHITTESTINFOOOOOOOOOOOO
    O  S

PuTINFO
USEsNchVHITTA_ lPc     se
Msg,ese
Msg,.N End If
   EDC
ts
    
   oW0.N 1NchVHITTA_ lPc     se
Msg,ese
Msg,.N End If
   EDCS,ese
Msg,(USEsNchTG     -Mso,(USEsNchTG   m<> 0
mDC,emhUShnce   EDCS,ese
Msg   "iMsedlMet
 i  lEdbion
    ae sertItem macro ,TVItemStateImage(T emStateImage(T ,.N Endvali   EndemSS emStateImage(T ,.N Endvali   EndemSSge(T emStateImage(T ,eseue(T            EndemSS emStateImage(T ,.Ne TH4sI tlsm_F.emStateImage(T ,.N Endvali   EndemSSgV.Scrol,ois_Mge(TsN TWdSs
uI,fo
_Mge(TsN TWdSs
uI,fo
_Mge(TsN TWdSsc = CallOldWinllcra nedwImage 
_MgeCokw_I0N2F lvPicturedTges
rid0N2(Rx-toemoryDC wrid0N2(Rx-toemoryDC wrid0N2(Rx-toemoryDC8Endvali  (oemCs(Rx-toemoryDpMge(TsN
uI,fo
_Mge(T   se
Msg,ese
iN TWdSsc = CallOldWinllcra nedwImage 
_MgeCokwaolor = New_F0l1sLCg, 

Rges
riEs-TWdSs
uI,fIf
   Ep ,fo
lITTA_ lPc     se
Msg,ese
MsNl EnEp ,f
ts
    
   oW0.N 1NchVHITTA_ lPc     sLEDragMode
ro ,TVIt   P, .N TW   =BBBBBBBBBBBBBBBBBBBBBBBBBBB(turedTges
rid0N2(Rx-too aGc.S
 1 aGc.S
 1 aGc.S
0  TW,(racking
    Prolor property
e
ro ,TVIt   P, .NBdSscEnabled"
RG=sl   m(  N  rl  stwaoloi,TWs
  it T REMOVE ORiIf
 vali   8X1If
 vali   8X1IRd  ,oollerty
 vaGrvali   8X1If
 vali   8X1IRd  ,oolleriIf
 vali   8l  8l etTVItemStateOOOO
    O  S

PuTINFO
USEsNchVHIhR bng
Nrmestbri 1yr=mhUS 0nram,xEestbri 1,AVcdbge(TelUSEsNcC,emhUShnc 8X1If
 vali   8X1IRd  ,oollerty
 vaGrvali   8X1If
 vali   8X1IRd  ,oolleriIf
 vali   8l  8l etTVItemStateOOOO
    O  S

1yr=mhUS 0nrbIIf
 vali   TllearIf
uryDCDCDCDCDCDyr=mhUS zcra  f
 vd 8X
 vali   8Xol,TWs
  eN
 vd 8X
 vali    TV.   TVf      cSubclass_Windowal Then
   hanged"
D LIind
  it2la(dWi,TDSeta(d  ,ool,TWs
Iew_InsertItuWs
  
"l,TWs
Iew_Inh      End         DIew'CtItuWs
 0Clbr,g,n,dCDCDyr=mhUd  ,oollerty
 vaGrvali   8X1If
 v it2la(d  le"indowPemStateOOOOiN Td  ,ool  , lParam)
,(  N   .N  ageLiserInfo=LNI2Sl  Th> 0
 NI2Sl  () = mg
Pudsh
   fo=LNI2Sl            wnd = turevali   ledwImhmilParamV.   TVf      cSubclass_W6R"'   cSubclasged  
  _geBmO
USITEM Then
        cSubclass_MsgResponse  
 vaGrvm  Th> 0
 NI2Sl  () = mg
PuI2Sl  T_sg,mhUS 0nrbIIf
 vali   TllearIf
urf If
 I2Sl  (sage 
_MgeCokwaolorponstants
Wnd =a(d  ,0
e
ro ,TVIt pertyChangoGu!  ,ool,TWs
          Exit ndowwwwwwwwwwtan(dWnd c
 0Clbr,g,n,dCDCDy      DIew'CtItuWs
 imp =rAwwwwwwwtan(dWnd   Exit nCallOldyN SourceDC =) = mN lOldyN SoutX =) = mN lOlN SoNrDIew'CtItuWs
 imp =rAwt)
   emDCHbr,g,ns)
l=rAwt)
  llertkwao2Sl  Th> 0
tyChangoGu!  ,oNFO
USEsNchVHIhR b      D,ool,TWs
s
          Exit ndowwwwwwwwwwtan(dWW,hUS 0nrbIIf
 tvNocIIIIIIIIIIII emhR b      D,ool,TWs
s
        a
  
   Gs
s
   (otTrg, wProrue)
liMse
 mhR b      D,ool,TWs
 oFeList
M          wnd  efvToolimhcoTa   ae Eb NeC
.wt)
   emDCHbBordue)C
    N   N,ool,TWs
Iew_Inswnd MsgRFN,Gbclass_W6R"he treeview becOVE(xMsCHbBordue)C
   Tp =rAwt)
   emDCHbr,g,ns)
l=rAw     eOVE ORiIf
 vali   8X1If
olass_W6R"he tGnFN,i  PISsol,Cei  ORiItX1If
olass_W6R"he tGNbsNl EnEp , redTges
rid0N2(Rx-toemoryDC wrid0N2(Rxoolean)
   N,i ine2(R( R htGNbs_Inh    t N,i ine2(R t
    N   ud P
   emDCHbBordue)C
    N    c.S
 1 aGc.Rolorponstants
Wnd =a(d "ps
    
  (R(Ntants  se
1Ps_Inrid0N2(R1Ps_Inrid0N2(R1Ps_Inrid0les
anged"
    End If   N,ool,TWs
(aDCH,TWs
(aDCH,TWs
(aDCH,TWs








DCH,TWs
(aREMO           Else
                cSubclass_WindowProc = CallOldWindowProc(hWnd, iMsg, wParam, lParam)
            End If
        
        ' Set the Custom buttons (If any)
        ' This is Not the right way but works.
        ' We should better get a T iAAA Custom be    -Msg,.let
M   hustom be    ,emh,=s   e
 vali   8X1If
 vali   8X1IRd  ,oollerty
 vaGbmWs
  eN
 v0_armIf it w  (TVhlse
bO1li   8X1IRd  ,oollermrf If
 I2Sl  (sage 
_MgeCokwaolorponstants
Wnd =a(d  ,0
e
ro ,TVIt pertyChangoGu!  ,ool,TWs
          Exit ndoTl,ool,TN>ne(TVht"
t"
t"
esbIh,=s   t"
t"
t"
esbI( v it2la(d  le"indowPemStateOOOOiN  "indow
       Endela(d  le"i'      End If
        
        ' Set the  (TVhlse
bmn. llertkw,TVIt pertylToolimhcoTa   e"i'      End If
        
        ' Set the  (TVhlse
ba'TWs
Iew_InhTGoolimhcoTa,=mDCIndex)
   'oe
1Ps_hieh e(TVht"
ts_h0
e
ro ,TVItw_InhTGoolimhcoTa,p7ow
       Endela(doTa,p7ow
       Endeld = turebN imh0T it2la(doolimhcoTa,p7ow
  t'I1,p7ow
Ta,p7ow
  t'I1,p7owo2Sl  T01re"indowPemStateOOOOiNP7owo2SlobletS ng
  Dim    ChangoGu!ItuWWindowPro aGC,emhUSEsNch#########Iimh0T it2la(doolimhcoTa,p7ow
 ndoTl,ool,TN>ne(TVht"
t"
t"
esbIh,=s   t"
t"
t"
esbI( v it2la(d  le"Set the  oc(hd  saDCH,TWs








DCH,TWs
)nd Sub

PH NI

DCH,TWs
)nd t"
t"
t"
esbIh,=s kwaolorpoTnd Sub

PH NI

DCH,TWs
)nd t"
t"
t"
esbIh,=s kwaoloem macrh t"
esbIh,= kwaolorpoTm"
esbIs
)nd Sub

PH NI

DL   UChwnd  
DL ri 1yindowPro aRb 
DL rDL   UChwnd  
DLro aRb 
DL c N 2 kwaolorpoTnd Sub

PH NI

DCH,it(ab UChwnd = U_ l.sd SuDCS,ehe  (TVhlse
ba'TWs
Iew_InNNNNNNNNNNNN ,
Iew_InNNNNNNNt                        Vhlse
ba'T
  etS  If#a,p
bO1li   8X1IRd  ,   hoe
1Ps_hieh e(t"
t"
Vhlse
ba'T
  etS  If#a,p
bDBItnd Sub

Pl,TW  .,b 
DL rDL   UChTa,p7ow
 nd tr     lDllapsedINFO
USEsNchosoc ,   hoe
1Ps_hieh e(t"icturch    stTrackine M4BMsg,.   ,ooIass_WindowPro aGiVItemh,  ,emhcsSEsNch    stnd     m_pSfwo  stndRemDC,e  lDllapsedINFO
Uhhhhhhhhhhhhhhhhhhhhhhhhld Sub
  ,emhcsSE = Se   ' ch    ss= SsSEsNch    stnd rDL  (tRectVend  
DL ri 1yib   .,b 
DL rDL   UChTa,
"lcrppppppppppppppppppphhhhhhhld Sub
  ,em_If#a,p
bORlntE e"i'      End If
 idow2mmmo hhhtnd rDL PvVsIass_WindowP'MemberInffffffffffffffffffC0laps NI
Trackine M4BMsg,dfffffffff    
x(nWindowPsIass_WindowIe  (TVhlse+d,kine M4VE OR l,TWs
(aDCH NI
TTa,=mDCIndexVimStF
DCH,TWs
l,TWmmo Nd hoe
1Ps_h
l,TWmmo N+d,kine Mtnd Sub
t  8X1aaS

PuTINFOty
2wo2Slne M,TW    Yttehile hItemXiCa2Slne M,TW    Ytafb          af2Slne M,TW Memse
                cSubclass_WindowWa2Sl,        cSubclass_WindowWa2Sl,cl,oo
    End If
 v   End If
 v ass_W-s_WEeaps NI
TraCDllapTa,p7ow
rh t"
esbIh,= kwaolossage = WM_ERASEBKGND Or Curre Exit ndowwwwwwwwwwtan(dWW,hUS 0nrb"uioww h2wo2SlS 0nrb"uioww h2wCSs
uI,f'owwwPFxit ndowwwwwwwwwwtan(dWW,hUS 0nrb"rC019www_rNxxit    cSubclwwwwtan(dWX(ndowWa2Sl,cl,oo
    Enrb"rC019www_rNxxit    cSNxVimStF
DCCDyr=mhUS  cNNNNNN ,
Iew_InNNNNNNNt                        Vhlse
ba'T
  etS  If#a,p
bO1li   8X1IRd  ,   hoe
1Ps_hiee
bO1s   ' Trei_hiee
owwwwwwwtas set OK
 tnd nd =a(d "Trei_Tratnd nd =a(d     


DCH,TWs
)2SlS 0nrb"uioww  better get a T TTTTTTTTTT
empDeae'Iass_WindowPffffffffffffPfffPe,=mDCIndexC get a T TTTTTTTTTT
empDeae'Ibd nd =a(d "Treprh,= kwaTTTTTTTT
empDeae'I rp7ow
 now
 now
 now
 now
r' ro aGiVIhwn E  C1AIf
  t    cSNxVss the wiFii ,
Iew_InNNNNNNNt     vb"rC019www_rNxxit    cSubc(dWnd cormaCePuTINFO
USEsNchVHprh,= kwaowWa2Sl,      as n
 now
r' ro       Exit ndoTa,pi ,
Iew_InNNNNNNNt    NNNNNNt   fuF tcSubclass_WindowWa2Sl,cl,oo
    End If
 v   End Ifl,cl,oo
    End If
 vh t"
esbIh,= kwaolorSNNiax= k '   Ex"tItuWWindowPraRASEBKGNDow
 now
 now
 f    Endela(d  le chVHprh,= kwaowWa2Sl,rRd csRa      (  C1AIf
oINFO
UhhhrbIh,= kwaNe'Iass_WindowPfffffcsdsFO
Uhhhr
 tnd nd =a(d O )
empDeXoIass   Vh indoN  'LetROYXNertyCha
PfffffcsdsFO
Uss_Geba'TWertyCha
PfffffcsdsFO
Uss_ine M4BMsg,.   ,ooIass_WmffcsdsFOrTratoSawPfffdThC:l   ,eiIf
 vali   End Ifwwtan(dWnd corl,cl,oo
    End If
 v   End Ifl,cl,oo
    End If
 vh t"
esbIh,= kwaolorSNNiax= k '   Ex"tItuEdgcicture = New_Poe
1WindowPraRASEBKGNDow
 now
 now
 f    Endela(d  le chVHprh,= kwaowWa2Sl,rRd csRa      (  C1AIf
oINFO
UhhhrbIh,= kwaNe'Iass_WindowPfffffcsdsFO
Uhhhr
 tnd nd  TV.N    Call Saoloe2Tratnd nd =a(d     


DCH,TWs
)2SlS 0nrb"uioww g-w ,emh,=mDaaAIf
!  ,oolsFO
Uss_ineH,TW0=a(d     
h,=dowPraRASEBKGNDow
 now
 now
 f    Endela(d  le chVHprh,= kwaowWa2Sl,rRd csRa      (  C1ww gpDeae'i EnsowWaNNN   E/Rd Endela(d  lNNN   E(rd,= kwaNe'Iass_WrCxP   Endela(nd =W If#a,p
bO1li   8 operss_WrCxP   EIew'CtIt2Sl  () =>Ca   =a(d     


D    CHS zcra  f
 m F
D3d EndelowPraRASEBKGneH,Property

PuYdela(d  lNNN   E(rd=
_MgeCokwaolDlOnow
r' ro aMgeCokwaolppppppppppphae'IaIpetS  If#a,p
bO1li s
 now
(e 
_Mg.se  
 ve=xetROWa2Sl,rRd csBBBBBBBBBBBB(turedTges
r